
/**
 * The WNumberArray class keeps track of a list (of fixed size) of integer values.
 * The list is assumed to be sorted smallest to largest when the WNumberList is created.
 *
 * @author (your name)
 * @version (a version number or a date)
 */
public class WNumberArray
{
    // instance variables
    private int[] nums;

    /**
     * Construct a new WNumberArray with a list of values.
     * @PRECONDITION the Array of int values must be sorted.
     */
    public WNumberArray(int[] values)
    {
        // initialize instance variables
        nums = values;
    }

    /**
     * This method identifies the mean (average) of the values
     * @return    the average of the values in the list
     */
    public double getMean()
    {
        // replace this code with your own
        return 0;
    }

    /**
     * Identifies the median (middle) of the values given. For an even number of
     * values in the list, the middle position will be the average of the two
     * central items. So, for values {0, 5, 9, 14}, the median will be the average
     * of 5 and 9, which is 7.
     * @return the median value in the list
     */
    public double getMedian()
    {
        // replace this code with your own
        return 0;
    }

    /**
     * Identifies the mode (most common value) in the list. If two values have 
     * equally common counts, the earlier value should be returned. So, for values
     * {1, 1, 2, 3, 3}, the mode will be the value 1.
     * @return the mode of the values in the Array
     * @PRECONDITION The values in the array should be sorted in increasing order
     */
    public int getMode()
    {
        int i = 1;
        int currentCount = 1;
        int mode = nums[0];
        int currentMode = nums[0];
        int modeCount = 1;
        while (i < nums.length)
        {
            if (nums[i] == nums[i - 1])  // if previous number matches this one
            {
                if (currentCount == 1)   // if we've just started counting
                {
                    currentMode = nums[i - 1];     // remember this value
                }
                currentCount++;                // Increment current values counted
                if (currentCount > modeCount)
                {
                    mode = currentMode;
                    modeCount = currentCount;
                }
            }
            else // if we've been counting, save results as needed
            {
                
                // now reset all values
                currentCount = 1;
                currentMode = nums[i];
            }
            i++;
        }     
        return mode;
    }
}
