
/**
 * The WSleepStudyTester uses the WSleepStudy class to analyze an experiment.
 *
 * @author (your name)
 * @version (a version number or a date)
 */
public class WSleepStudyTester
{
    public static final double EPSILON = 0.0000000001;
    
    public static void main(String[] args)
    {
        int testsPassed = 0;
        WSleepStudy study = new WSleepStudy();
        testsPassed++;
        System.out.println("WSleepStudy contruction: passed");
        System.out.println("Tests passed: " + testsPassed + "/7");
        study.addSubject("Richard",8);
        testsPassed++;
        System.out.println("WPerson added: passed");
        System.out.println("Tests passed: " + testsPassed + "/7");
        WPerson brother1 = new WPerson("David",10);
        study.addSubject(brother1);
        testsPassed++;
        System.out.println("WPerson added (overload): passed");
        System.out.println("Tests passed: " + testsPassed + "/7");
        study.addSubject("Kevin",7);
        study.addSubject("Stephen",6.5);
        int numOfSubjects = study.studySize();
        System.out.println("studySize() call: passed");
        testsPassed++;
        System.out.println("Tests passed: " + testsPassed + "/7");
        if (study.studySize() == 4)
        {
            testsPassed++;
            System.out.println("studySize correctly returned");
        }
        else
        {
            System.out.println("studySize incorrectly returned");
        }
        System.out.println("Tests passed: " + testsPassed + "/7");
        double avgSleep = study.getAverageSleep();
        System.out.println("getAverageSleep() call: passed");
        testsPassed++;
        System.out.println("Tests passed: " + testsPassed + "/7");
        if (Math.abs(avgSleep - 7.875) < EPSILON)
        {
            testsPassed++;
            System.out.println("average sleep correctly calculated");
        }
        else
        {
            System.out.println("average sleep incorrectly calculated");
        }
        System.out.println("Tests passed: " + testsPassed + "/7");
        
    }
}
