
/**
 * The WCashRegisterTester tests the WCashRegister and WCoin
 * classes by trying to buy some stuff, paying for it, and
 * getting change back.
 *
 * @author (your name)
 * @version (a version number or a date)
 */
public class WCashRegisterTester
{
    public static final double EPSILON = 1E-10;
    
    public static void main(String[] args)
    {
        int testsPassed = 0;
        WCashRegister cr = new WCashRegister();
        testsPassed++;
        System.out.println("WCashRegister contruction: passed");
        System.out.println("Tests passed: " + testsPassed + "/8");
        cr.recordPurchase(1); // one dollar
        System.out.println(".recordPurchase method call: passed");
        testsPassed++;
        System.out.println("Tests passed: " + testsPassed + "/8");
        cr.recordPurchase(0.51);
        double purchases = cr.getPurchaseAmount();
        System.out.println(".getPurchaseAmount method call: passed");
        testsPassed++;
        System.out.println("Tests passed: " + testsPassed + "/8");
        if (Math.abs(purchases - 1.51) < EPSILON)
        {
            testsPassed++;
            System.out.println("purchases correctly registered");
        }
        else
        {
            System.out.println("purchases incorrectly registered");
        }
        System.out.println("Tests passed: " + testsPassed + "/8");
        // Let's give some money now!
        cr.takePayment(new WCoin("quarter", 0.25), 8);
        System.out.println(".takePayment method call (with Coin object): passed");
        testsPassed++;
        System.out.println("Tests passed: " + testsPassed + "/8");
        cr.takePayment("Bitcoin", 16000, 0.25);
        System.out.println(".receivePayment method call (with new coin): passed");
        testsPassed++;
        System.out.println("Tests passed: " + testsPassed + "/8");
        double change = cr.getChange();
        System.out.println(".getChange method call: passed");
        testsPassed++;
        System.out.println("Tests passed: " + testsPassed + "/8");
        if (Math.abs(change - 4000.49) < EPSILON)
        {
            testsPassed++;
            System.out.println("change correctly returned");
        }
        else
        {
            System.out.println("change incorrectly returned");
        }
        System.out.println("Tests passed: " + testsPassed + "/8");
    }
}
