
/**
 * The WNumberArrayTester creates a series of number lists and tests them.
 *
 * @author (your name)
 * @version (a version number or a date)
 */
public class WNumberArrayTester
{
    public static final double EPSILON = 0.00000000001;
    
    public static void main(String[] args)
    {
        int testsPassed = 0;
        int[] values = {0, 1, 1, 2, 2, 2};
        WNumberArray n1 = new WNumberArray(values);
        int[] values2 = {0, 1, 2, 3, 4};
        WNumberArray n2 = new WNumberArray(values2);
        testsPassed++;
        System.out.println("WNumberArray contruction: passed");
        System.out.println("Tests passed: " + testsPassed + "/8");
        double mean = n1.getMean();
        System.out.println("getMean call: passed");
        testsPassed++;
        System.out.println("Tests passed: " + testsPassed + "/8");
        if (Math.abs(mean - 8.0/6) < EPSILON)
        {
            testsPassed++;
            System.out.println("mean value correctly calculated");
        }
        else
        {
            System.out.println("mean value incorrectly calculated");
        }
        System.out.println("Tests passed: " + testsPassed + "/8");
        
        double median = n1.getMedian();
        System.out.println("getMedian call: passed");
        testsPassed++;
        System.out.println("Tests passed: " + testsPassed + "/8");
        
        if (Math.abs(n2.getMedian() - 2) < EPSILON)
        {
            testsPassed++;
            System.out.println("median value for array with odd number of values correctly determined");
        }
        else
        {
            System.out.println("median value for array with odd number of values incorrectly determined");
        }
        System.out.println("Tests passed: " + testsPassed + "/8");
        
        if (Math.abs(n1.getMedian()-1.5) < EPSILON)
        {
            testsPassed++;
            System.out.println("median value for array with even number of values correctly determined");
        }
        else
        {
            System.out.println("median value for array with even number of values incorrectly determined");
        }
        System.out.println("Tests passed: " + testsPassed + "/8");
        
        
        int mode = n1.getMode();
        System.out.println("getMode call: passed");
        testsPassed++;
        System.out.println("Tests passed: " + testsPassed + "/8");
        
        if (mode == 2)
        {
            testsPassed++;
            System.out.println("mode value correctly determined");
        }
        else
        {
            System.out.println("mode value incorrectly determined");
        }
        System.out.println("Tests passed: " + testsPassed + "/8");
        
    }
}
